"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _require = require('util'),
    promisify = _require.promisify;

var _require2 = require('path'),
    relative = _require2.relative,
    resolve = _require2.resolve,
    extname = _require2.extname;

var mime = require('mime-types');

var fs = require('fs');

var readdir = promisify(fs.readdir);
var stat = promisify(fs.stat);

function getFiles(_x) {
  return _getFiles.apply(this, arguments);
}

function _getFiles() {
  _getFiles = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(dir) {
    var subdirs, files;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return readdir(dir);

          case 2:
            subdirs = _context3.sent;
            _context3.next = 5;
            return Promise.all(subdirs.map( /*#__PURE__*/function () {
              var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(subdir) {
                var res;
                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        res = resolve(dir, subdir);
                        _context2.next = 3;
                        return stat(res);

                      case 3:
                        if (!_context2.sent.isDirectory()) {
                          _context2.next = 7;
                          break;
                        }

                        _context2.t0 = getFiles(res);
                        _context2.next = 8;
                        break;

                      case 7:
                        _context2.t0 = res;

                      case 8:
                        return _context2.abrupt("return", _context2.t0);

                      case 9:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2);
              }));

              return function (_x3) {
                return _ref.apply(this, arguments);
              };
            }()));

          case 5:
            files = _context3.sent;
            return _context3.abrupt("return", files.reduce(function (a, f) {
              return a.concat(f);
            }, []));

          case 7:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _getFiles.apply(this, arguments);
}

var _default = function _default(pluginOptions) {
  return {
    afterExport: function () {
      var _afterExport = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(state) {
        var DIST, metadata, data;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                DIST = state.config.paths.DIST;
                metadata = {};
                _context.next = 4;
                return getFiles(DIST).then(function (files) {
                  files.forEach(function (item, index) {
                    var key = relative(DIST, item);
                    var mimeType = mime.contentType(extname(item));
                    metadata[key] = mimeType;
                  });
                });

              case 4:
                data = JSON.stringify(metadata);
                fs.writeFileSync(DIST + '/metadata.json', data);
                return _context.abrupt("return", state);

              case 7:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function afterExport(_x2) {
        return _afterExport.apply(this, arguments);
      }

      return afterExport;
    }()
  };
};

exports["default"] = _default;